# eric7.Project.IdlCompilerOptionsDialog

Module implementing a dialog to enter some IDL compiler options.

### Global Attributes

None

### Classes

IdlCompilerOptionsDialog | Class implementing a dialog to enter some IDL compiler options.

### Functions

None

## IdlCompilerOptionsDialog

Class implementing a dialog to enter some IDL compiler options.

### Derived from

QDialog, Ui_IdlCompilerOptionsDialog

### Class Attributes

None

### Class Methods

None

### Methods

IdlCompilerOptionsDialog | Constructor
__definedNamesContain | Private method to test, if the currently defined 'Defined Names' contain a given one.
__generateDefinedNamesList | Private method to prepare the list of 'Defined Names'.
__generateIncludeDirectoriesList | Private method to prepare the list of 'Include Directories'.
__generateUndefinedNamesList | Private method to prepare the list of 'Undefined Names'.
__includeDirectoriesContain | Private method to test, if the currently defined 'Include Directories' contain a given one.
__populateDefineNamesList | Private method to populate the list of defined names.
__populateIncludeDirectoriesList | Private method to populate the 'Include Directories' list.
__undefinedNamesContain | Private method to test, if the currently defined 'Undefined Names' contain a given one.
__updateDefineNameButtons | Private method to set the state of the 'Define Name' buttons.
__updateIncludeDirectoryButtons | Private method to set the state of the 'Include Directory' buttons.
__updateUndefineNameButtons | Private method to set the state of the 'Undefine Name' buttons.
getData | Public method to return the data entered by the user.
on_dnAddButton_clicked | Private slot to add a 'Define Name' entry.
on_dnDeleteButton_clicked | Private slot to delete the selected 'Define Name' entry.
on_dnEditButton_clicked | Private slot to edit the selected 'Define Name' entry.
on_dnList_itemSelectionChanged | Private slot handling the selection of a 'Define Name' entry.
on_idAddButton_clicked | Private slot to add an 'Include Directory'.
on_idDeleteButton_clicked | Private slot to delete the selected 'Include Directory' entry.
on_idEditButton_clicked | Private slot to edit the selected 'Include Directory' entry.
on_idList_itemSelectionChanged | Private slot handling the selection of an 'Include Directory' entry.
on_unAddButton_clicked | Private slot to add a 'Undefine Name' entry.
on_unDeleteButton_clicked | Private slot to delete the selected 'Undefine Name' entry.
on_unEditButton_clicked | Private slot to edit the selected 'Undefine Name' entry.
on_unList_itemSelectionChanged | Private slot handling the selection of a 'Undefine Name' entry.

### Static Methods

None

#### IdlCompilerOptionsDialog (Constructor)

IdlCompilerOptionsDialog(includeDirectories, definedNames, undefinedNames, project=None, parent=None, )

Constructor

includeDirectories (list of str)
  list of include directories
definedNames (list of str)
  list of defined variables with name and value separated by '='
undefinedNames (list of str)
  list of undefined names
project (Project)
  reference to the project object
parent (QWidget)
  reference to the parent widget

#### IdlCompilerOptionsDialog.__definedNamesContain

__definedNamesContain(name)

Private method to test, if the currently defined 'Defined Names' contain a given one.

name (str)
  variable name to be tested

Return:
  flag indicating that the given name is already included

Return Type:
  bool

#### IdlCompilerOptionsDialog.__generateDefinedNamesList

__generateDefinedNamesList()

Private method to prepare the list of 'Defined Names'.

Return:
  list of 'Defined Names'

Return Type:
  list of str

#### IdlCompilerOptionsDialog.__generateIncludeDirectoriesList

__generateIncludeDirectoriesList()

Private method to prepare the list of 'Include Directories'.

Return:
  list of 'Include Directories'

Return Type:
  list of str

#### IdlCompilerOptionsDialog.__generateUndefinedNamesList

__generateUndefinedNamesList()

Private method to prepare the list of 'Undefined Names'.

Return:
  list of 'Undefined Names'

Return Type:
  list of str

#### IdlCompilerOptionsDialog.__includeDirectoriesContain

__includeDirectoriesContain(directory)

Private method to test, if the currently defined 'Include Directories' contain a given one.

directory (str)
  directory name to be tested

Return:
  flag indicating that the given directory is already included

Return Type:
  bool

#### IdlCompilerOptionsDialog.__populateDefineNamesList

__populateDefineNamesList(definedNames)

Private method to populate the list of defined names.

definedNames (list of str)
  list of defined variables with name and value separated by '='

#### IdlCompilerOptionsDialog.__populateIncludeDirectoriesList

__populateIncludeDirectoriesList(includeDirectories)

Private method to populate the 'Include Directories' list.

includeDirectories (list of str)
  list of include directories

#### IdlCompilerOptionsDialog.__undefinedNamesContain

__undefinedNamesContain(name)

Private method to test, if the currently defined 'Undefined Names' contain a given one.

name (str)
  variable name to be tested

Return:
  flag indicating that the given name is already included

Return Type:
  bool

#### IdlCompilerOptionsDialog.__updateDefineNameButtons

__updateDefineNameButtons()

Private method to set the state of the 'Define Name' buttons.

#### IdlCompilerOptionsDialog.__updateIncludeDirectoryButtons

__updateIncludeDirectoryButtons()

Private method to set the state of the 'Include Directory' buttons.

#### IdlCompilerOptionsDialog.__updateUndefineNameButtons

__updateUndefineNameButtons()

Private method to set the state of the 'Undefine Name' buttons.

#### IdlCompilerOptionsDialog.getData

getData()

Public method to return the data entered by the user.

Return:
  tuple containing the list of include directories, list of defined names and list of undefined names

Return Type:
  tuple of (list of str, list of str, list of str)

#### IdlCompilerOptionsDialog.on_dnAddButton_clicked

on_dnAddButton_clicked()

Private slot to add a 'Define Name' entry.

#### IdlCompilerOptionsDialog.on_dnDeleteButton_clicked

on_dnDeleteButton_clicked()

Private slot to delete the selected 'Define Name' entry.

#### IdlCompilerOptionsDialog.on_dnEditButton_clicked

on_dnEditButton_clicked()

Private slot to edit the selected 'Define Name' entry.

#### IdlCompilerOptionsDialog.on_dnList_itemSelectionChanged

on_dnList_itemSelectionChanged()

Private slot handling the selection of a 'Define Name' entry.

#### IdlCompilerOptionsDialog.on_idAddButton_clicked

on_idAddButton_clicked()

Private slot to add an 'Include Directory'.

#### IdlCompilerOptionsDialog.on_idDeleteButton_clicked

on_idDeleteButton_clicked()

Private slot to delete the selected 'Include Directory' entry.

#### IdlCompilerOptionsDialog.on_idEditButton_clicked

on_idEditButton_clicked()

Private slot to edit the selected 'Include Directory' entry.

#### IdlCompilerOptionsDialog.on_idList_itemSelectionChanged

on_idList_itemSelectionChanged()

Private slot handling the selection of an 'Include Directory' entry.

#### IdlCompilerOptionsDialog.on_unAddButton_clicked

on_unAddButton_clicked()

Private slot to add a 'Undefine Name' entry.

#### IdlCompilerOptionsDialog.on_unDeleteButton_clicked

on_unDeleteButton_clicked()

Private slot to delete the selected 'Undefine Name' entry.

#### IdlCompilerOptionsDialog.on_unEditButton_clicked

on_unEditButton_clicked()

Private slot to edit the selected 'Undefine Name' entry.

#### IdlCompilerOptionsDialog.on_unList_itemSelectionChanged

on_unList_itemSelectionChanged()

Private slot handling the selection of a 'Undefine Name' entry.

Up